/* 
STATUS OK
Version 1.2017_07_27
Kompiliert unter Arduino 1.8.3 

1. Unter Verwendung der mit Arduino 1.8.3 mitglieferten library:
LiquidCrystal:
...\arduino-1.8.3\libraries\LiquidCrystal\src\LiquidCrystal.cpp
...\arduino-1.8.3\libraries\LiquidCrystal\src\LiquidCrystal.h

2. Verwendete Hardware, die bei mir funktioniert
3.1 LCD KeypadShield
3.2 Arduino UNO R3
*/
#include <LiquidCrystal.h>
// select the pins used on the LCD panel
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

// define some values used by the panel and buttons
int lcd_key     = 0;
int adc_key_in  = 0;
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

// Function read the buttons
int read_LCD_buttons()
{
  // read value on adc input A0
  adc_key_in = analogRead(0);
  /**********************************************************/
  // make sure pushed button on keypadshield equals 
  // printed return value.
  // change threshold if needed
  /**********************************************************/
  //               threshold:      return value:
  /**********************************************************/
  if (adc_key_in >    1000)        return btnNONE;
  if (adc_key_in <    50)          return btnRIGHT;
  if (adc_key_in <    150)         return btnUP;
  if (adc_key_in <    300)         return btnDOWN  ;
  if (adc_key_in <    500)         return btnLEFT;
  if (adc_key_in <    700)         return btnSELECT;
  return btnNONE;  // when all others fail, return this...
}


void setup()
{
  lcd.begin(16, 2);              // start the library
}

void loop()
{
  // call function and store return value in variable lcd_key
  lcd_key = read_LCD_buttons();  // read the buttons

  switch (lcd_key)               // depending on which button was pushed, we perform an action
  {
    case btnRIGHT:
      {
        lcd.setCursor(0, 0);           // move to the begining of the first line
        lcd.print("Mapping correct?"); // print a simple message
        lcd.setCursor(0, 1);           // move to the begining of the second line
        lcd.print(adc_key_in);         // print value on adc input A0
        lcd.print(" ");
        lcd.print("btnRIGHT    ");     // print a simple message
        break;
      }
    case btnLEFT:
      {
        lcd.setCursor(0, 0);           // move to the begining of the first line
        lcd.print("Mapping correct?");
        lcd.setCursor(0, 1);           // move to the begining of the second line
        lcd.print(adc_key_in);         // print value on adc input A0
        lcd.print(" ");
        lcd.print("btnLEFT     ");     // print a simple message
        break;
      }
    case btnUP:
      {        
        lcd.setCursor(0, 0);           // move to the begining of the first line
        lcd.print("Mapping correct?");
        lcd.setCursor(0, 1);           // move to the begining of the second line
        lcd.print(adc_key_in);         // print value on adc input A0
        lcd.print(" ");
        lcd.print("btnUP      ");      // print a simple message
        break;
      }
    case btnDOWN:
      {
        lcd.setCursor(0, 0);           // move to the begining of the first line
        lcd.print("Mapping correct?");
        lcd.setCursor(0, 1);           // move to the begining of the second line
        lcd.print(adc_key_in);         // print value on adc input A0
        lcd.print(" ");
        lcd.print("btnDOWN    ");      // print a simple message
        break;
      }
    case btnSELECT:
      {
        lcd.setCursor(0, 0);           // move to the begining of the first line
        lcd.print("Mapping correct?");
        lcd.setCursor(0, 1);           // move to the begining of the second line
        lcd.print(adc_key_in);         // print value on adc input A0
        lcd.print(" ");
        lcd.print("btnSELECT  ");      // print a simple message
        break;
      }
    case btnNONE:
      {
        lcd.setCursor(0, 0);           // move to the begining of the first line
        lcd.print("Push the buttons"); // print a simple message
        lcd.setCursor(0, 1);           // move to the begining of the second line
        lcd.print(adc_key_in);         // print value on adc input A0
        lcd.print(" ");
        lcd.print("NONE       ");      // print a simple message
        break;
      }
  }
}

